;;;                                                     ( achtdame.s)
;;; Problem der acht Damen :
;;;    ( Hier auch fuer andere Anzahlen )
;;; Ein Beispiel fuer backtracking bei mehreren Loesungen
;;; Eine Loesung mit Hilfe von Listen ist dabei sicher nicht optimal.
;;;-------------------------------------------------------------------
; Die Damen werden -beginnend in der ersten Zeile- Zeile fuer Zeile ge-
; setzt. Daher muss in der Zeile nicht geprueft werden. Eine Pruefung 
; muss aber fuer Spalten und Diagonalen erfolgen. 
; Dies ist einfach zu erledigen, wenn jeweils die nachfolgenden Zeilen
; an die Bedrohungssituation angepasst werden.
(require (lib "breakpoint.ss"))


(define
   (acht n) 
   (let
;      Schleife
      ((F (Feld n)))
      (Zeige F)))

(define                              ; Feld im car: aktuelle Zeile
   (setze Z-Nr Sp-Nr Feld akku)
;   (bkpt "in setze " (list Z-Nr Sp-Nr Feld akku)) 
   (cond
      ((null? Feld) (writeln (reverse akku)))
      ; Eine Loesung gefunden    (Ende vom Feld)
      ((> Sp-Nr 8) '())
      ; So keine Loesung moeglich (Ende der Zeile)
      (else
         (if
            (eq? (n-tes Sp-Nr (car Feld)) 'X)    ; unbedrohtes Feld
            (setze 
               (add1 Z-Nr)
               1
               (noch-frei Sp-Nr (cdr Feld))  ; korrigiertes Restfeld
               (cons (list Z-Nr Sp-Nr) akku)))
         ; Wegen der Rekursion in der Breite muss in jedem Fall :
         (setze Z-Nr (add1 Sp-Nr) Feld akku))))

(define
   (besetze Position Zeile)
   (cond
      ((> Position 8) (error "falsche Position besetzt" Position))
      ((< Position 0) (error "falsche Position besetzt" Position))
      ((= Position 1) (cons 'B (cdr Zeile)))
      (else
         (cons (car Zeile) (besetze (sub1 Position) (cdr Zeile))))))

(define
   (nach-unten Sp-Nr Feld)
   (if
      (null? Feld) 
      '()
      (cons 
         (besetze Sp-Nr (car Feld)) 
         (nach-unten Sp-Nr (cdr Feld)))))
      
(define
   (nach-links-unten Sp-Nr Feld)
   (cond
      ((null? Feld) '())
      ((< Sp-Nr 1) Feld)
      (else
         (cons 
            (besetze Sp-Nr (car Feld)) 
            (nach-links-unten (sub1 Sp-Nr) (cdr Feld))))))
      
(define
   (nach-rechts-unten Sp-Nr Feld)
   (cond
      ((null? Feld) '())
      ((> Sp-Nr 8) Feld)
      (else
         (cons 
            (besetze Sp-Nr (car Feld)) 
            (nach-rechts-unten (add1 Sp-Nr) (cdr Feld))))))
      
(define
   (noch-frei Sp-Nr Feld)
   (nach-links-unten (sub1 Sp-Nr)
      (nach-rechts-unten (add1 Sp-Nr)
         (nach-unten Sp-Nr Feld))))

;---------------------------------------------------------------------
(define
   (Feld wieviel)
   (let
      Schleife 
      ((L '())
       (n wieviel))
      (if
         (positive? n)
         (Schleife (cons (Zeile wieviel) L) (sub1 n))
         L)))

(define 
   (Zeile wieviel)
   (let
      Schleife 
      ((L '())
       (n wieviel))
      (if
         (positive? n)
         (Schleife (cons 'X L) (sub1 n))
         L)))
(define
   (Zeige Feld)
   (let
      loop1
      ((F Feld))
      (cond
         ((null? F) *the-non-printing-object*)
         (else
            (let
               loop2
               ((Zeile (car Feld)))
               (cond
                  ((null? Zeile) (writeln))
                  (else
                     (write (car Zeile))
                     (loop2 (cdr Zeile)))))
            (loop1 (cdr F))))))

(define
   (n-tes n aus-L)
   (let
      luhp
      ((i n)
       (L aus-L))
      (cond
         ((null? L) (error "unzulaessige Parameter :" (list n aus-L)))
         ((= i 1) (car L))
         (else
            (luhp (sub1 i) (cdr L))))))
;;;-------------------------------------------------------------------
;;; Selbststart des Programmes :

(setze 1 1 (Feld 8) ())
