;;; <grafik-fuer-rucksack.scm>
; Fr die einfache grafische Darstellung bentigen wir nur einen Rucksack
; und Rechtecke zur Darstellung.

;;; ===== Starten der Grafik : =====
(require (lib "graphics.ss" "graphics"))
(open-graphics)
(define fenster (open-viewport "viewport" 750 250))
;;; ===== Beenden der Grafik =====
(define
  (Grafik-beenden)
  ;(display "Abbruch mit Taste im Grafikfenster")(warte)
  (close-viewport fenster)
  (close-graphics))

;;; ===== erzeuge-Rucksack =====
; erzeuge-Rucksack ist eine Klasse, welche die Methoden 
; --- fuege-hinzu
; --- entferne           
; --- zeige
; --- zeige-groesse
; --- zeige-laenge            kennt
; Verwendet wird hier die einfache (selbst geschriebene) OO.
; Maximalgre --> Rucksackobjekt
; oder
; Maximalgre x Liste von Stcken --> Rucksackobjekt
(define
  (erzeuge-rucksack groesse . init-rucksack)
  (let
      ((Stuecke
        (if
         (null? init-rucksack)
         '()
         (car init-rucksack))))
    (lambda (message . parameter)
      (cond
        ((equal? message 'fuege-hinzu)
         (if (or
              (null? parameter)
              (not (integer? (car Parameter)))
              (> (+ (apply + Stuecke) (car parameter)) groesse))
             'geht-nicht!
             (begin
               (set! Stuecke (cons (car parameter) Stuecke))
               (apply + Stuecke))))
        ((equal? message 'entferne)
         (if
          (not (null? Stuecke))
          (set! Stuecke (cdr Stuecke)))
          Stuecke)
        ((equal? message 'zeige)
          Stuecke)
        ((equal? message 'zeige-groesse)
          groesse)
        ((equal? message 'zeige-laenge)
          (apply + Stuecke))
        (else
         'falsche message)))))

;;; ===== zeichne-Rucksack =====
; Der "Rucksack wird als Streifen der Breite 30 gezeichnet.
; Mchte man mehrere Ruckscke
; Rucksack --> void    [Nebeneffekt grafische Darstellung]
(define
  (zeichne-Rucksack rucksack)
  ((clear-viewport fenster)) 
  ((draw-solid-rectangle fenster) 
   (make-posn 8 8) 
   (+ 4 (rucksack 'zeige-groesse))
   34
   (make-rgb 0.8 0.3 0.3))
  (let loop
    ((liste (reverse (rucksack 'zeige)))
     (x-Position 0))
    (cond
      ((null? liste) (void))
      (else 
       ((draw-rectangle fenster)
        (make-posn (+ 10 x-Position) 10)
        (car liste)
        30
        (make-rgb 0 0 1))
       (loop (cdr liste) (+ x-Position (car liste)))))))

;;; ===== Hilfsfunktionen =====
(require (lib "breakpoint.ss")) ; ggf ndern in (load "breakpoint.ss")
; warte funktioniert nur bei Grafikfenstern.
; Die Funktion wartet auf <LEERTASTE>.
(define 
  (warte)
  ;(let loop ((i (add1 (current-seconds)))) (if (<= (current-seconds) i) (loop i)))
  (viewport-flush-input fenster)
  (if (not (equal? (key-value (get-key-press fenster)) #\space)) (warte)))

;;; ----- Test-Rucksack -----
(define mein-rucksack (erzeuge-rucksack 100))

; ===== Test mit Eingabe =====
; Funktion zum Simulieren und darstellen des Fllens und
; des Leeren eines Rucksacks.
(define
  (Eingabe-Schleife rucksack)
  (display "hinein positiv  --- heraus negativ --- Abbruch mit 0")
  (newline)
  (let loop
    ((eingabe (read)))
    (cond
      ((not (integer? eingabe))
       (loop (read)))
      ((zero? eingabe)
       (Grafik-beenden))
      ((negative? eingabe)
       (rucksack 'entferne)
       (rucksack 'zeige)
       (rucksack 'zeige-laenge)
       (zeichne-Rucksack rucksack)
       (loop (read)))
      (else
       (rucksack 'fuege-hinzu eingabe)
       (rucksack 'zeige)
       (rucksack 'zeige-laenge)
       (zeichne-Rucksack rucksack)
       (loop (read))))))
; Aufrufe:
;(Eingabe-Schleife mein-rucksack)
;(Grafik-beenden)
