;;; "Grafik-zu-rucksack-gierig.scm"

;;; ===== Daten =====
; ----- Liste der vorhandenen Stuecke -----
(define stuecke '(30 30 30 20 20 15 5 2 1))
(define ladung '())
(define ziel 100)

;; Verwendet die PLT MrEd: Graphical Toolbox
;;;; ====== Grafik =====
;; erzeuge ein dialog - Objekt
(define dialog (instantiate dialog% ("Rucksack fuellen")))

;; horizontal panel dem dialog hinzufuegen
(define horizontal-panel (new horizontal-panel% (parent dialog)))

;; vertical panel dem horizontal-panel hinzufuegen
(define vertical-panel (new vertical-panel% (parent horizontal-panel) (alignment '(center center))))

;;; ===== list-box zur Anzeige der noch vorhandenen Stuecke =====
;(new list-box% (label _) (choices _) (parent _) [(callback _)] [(style _)] [(selection _)] [(font _)] [(label-font _)] [(enabled _)] [(vert-margin _)] [(horiz-margin _)] [(min-width _)] [(min-height _)] [(stretchable-width _)] [(stretchable-height _)])
(define
  stuecke-list-box
  (new
   list-box%
   (label "vorhandene Stuecke:")
   (choices (map number->string stuecke))
   (parent horizontal-panel)))
(send stuecke-list-box min-height (* 14 (length stuecke)))

;;; ===== list-box zur Anzeige der noch geladenen Stuecke =====
(define
  ladung-list-box
  (new
   list-box%
   (label "geladene Stuecke:")
   (choices '())
   (parent horizontal-panel)))
(send ladung-list-box min-height (* 14 (length stuecke)))

;;; ===== ladung-text-field =====
;(new text-field% (label _) (parent _) [(callback _)] [(init-value _)] [(style _)] [(font _)] [(enabled _)] [(vert-margin _)] [(horiz-margin _)] [(min-width _)] [(min-height _)] [(stretchable-width _)] [(stretchable-height _)])
(define
  ladung-text-field
  (new text-field% (label "Ladung") (parent vertical-panel) (init-value "") (enabled #f) (min-width 30)))

;;; ===== weiter-button =====
;(new button% (label _) (parent _) [(callback _)] [(style _)] [(font _)] [(enabled _)] [(vert-margin _)] [(horiz-margin _)] [(min-width _)] [(min-height _)] [(stretchable-width _)] [(stretchable-height _)]) 
; für den weiter-Button die aktion und das Objekt
; der ja-Button wird dem vertical panel hinzugefügt
(define
  weiter-aktion
  (lambda (b e)
    (cond
      ((null? stuecke)(display "Keine Stuecke mehr vorhanden!")(newline))
      ((= (+ (car stuecke) (apply + ladung)) ziel)
       (display "Container gefüllt!")(newline)
       (send stuecke-list-box delete 0)
       (send ladung-list-box append (number->string (car stuecke)) (car stuecke))
       (set! ladung (cons (car stuecke) ladung))
       (send ladung-text-field set-value (number->string (apply + ladung)))
       (set! stuecke (cdr stuecke)))
      ((> (+ (car stuecke) (apply + ladung)) ziel)
       (display (car stuecke))(display " passt nicht hinein!")(newline)
       (send stuecke-list-box delete 0)
       (set! stuecke (cdr stuecke)))
      (else
       (display "lade: ")(display (car stuecke)) (newline)
       (send stuecke-list-box delete 0)
       (send ladung-list-box append (number->string (car stuecke)) (car stuecke))
       (set! ladung (cons (car stuecke) ladung))
       (send ladung-text-field set-value (number->string (apply + ladung)))
       (set! stuecke (cdr stuecke))))))
(define weiter-button (instantiate button% ("  WEITER  " vertical-panel weiter-aktion)))


;; für den beenden-Button die aktion und das Objekt
; der beenden-Button wird dem vertical panel hinzugefügt
(define beenden-aktion (lambda (b e) (display 'beendet)(newline)(send dialog show #f)))
(define beenden-button (instantiate button% ("Beenden" vertical-panel beenden-aktion)))




(send dialog show #t)

