;;; Rucksack greedy grafik.scm
(require (lib "breakpoint.ss"))
(load "grafik-fuer-rucksack.scm")
; Erster Lsungsansatz zum [Rucksackproblem] linearen Container - 
; Lade - Problem mit einer gierigen Strategie. Die Teilgewichte sollten
; der Grsse nach geordnet vorliegen. Anderenfalls muss man sie so
; sortieren.
; Es ist zu klren, ob Satisfizierung oder Optimierung gewnscht wird.
;;; ===== Rucksack-packen ============================================
; Bei diesem Algorithmus ist eine einfache Rekursion mglich. Sie ist
; aber wegen der Abbruchbedingungen unhandlich. Also endrekursiv mit
; Akku {Ergebnis}
; Gesamtgewicht x sortierte Liste der mglichen Teilgewichte x ()
;              --> Liste der optimalen TG
; 1. Fall: genau erfllen (Satisfizierung)
(define
  (Rucksack-packen Gewicht Teilgewichte Ergebnis rucksack)
  (zeichne-Rucksack rucksack)(warte)
  (cond
    ((zero? Gewicht)          ; Lsung gefunden !
     (writeln (reverse Ergebnis))
     Ergebnis)
    ((null? Teilgewichte)     ; nicht lsbar
     (writeln "gescheitert" (reverse Ergebnis))
     #f)
    ((< Gewicht (car Teilgewichte))        ; erster geht nicht
     (Rucksack-packen Gewicht (cdr Teilgewichte) Ergebnis rucksack) rucksack)
    (else              ; einpacken und weiter
     (rucksack 'fuege-hinzu (car Teilgewichte))
     (Rucksack-packen
      (- Gewicht (car Teilgewichte))
      (cdr Teilgewichte)
      (cons (car Teilgewichte) Ergebnis)
      rucksack))))
     
(define
  (Test-mit-Grafik Maximal-Gewicht Teilgewichte)
  (let
      ((rucksack (erzeuge-rucksack Maximal-Gewicht '())))
    
    (Rucksack-packen Maximal-Gewicht Teilgewichte () rucksack)))

(define Teilgewichte-a '(30 30 30 20 20 20 15 15 5 3 2 1 1))
;(define Teilgewichte-b '(900 400 181 90 50 20 9 5 2 1))
(Test-mit-Grafik 103 Teilgewichte-a)