;;; rucksack mit tiefensuche einfach.scm
;;; Eine einfache Lsung des Rucksackproblems mit Tiefensuche
;;; Die Funktion Rucksack-packen bildet eine Aufrufhlle fr die 
;;; eigentliche Tiefensuchefunktion. Dadurch braucht der Benutzer
;;; nicht beim Aufruf die leere Liste fr den akku zu bergeben.
;;; Auerdem ergibt sich der Vorteil, dass der Parameter Gewicht
;;; fr die innere Funktion global ist und daher nicht in der
;;; Aufrufkette mit geschleppt werden muss.

(define
  (Rucksack-packen Gewicht Teilgewichte)
  (let t-s
    ((Teilgewichte Teilgewichte)
     (akku '()))
    (cond
      ((= Gewicht (apply + akku))
       akku)
      ((null? Teilgewichte) #f)
      ; erster Fall: einpacken!
      ((t-s (cdr Teilgewichte) (cons (car Teilgewichte) akku)))
      (else
       ; die einzige Alternative: nicht einpacken!
       (t-s (cdr Teilgewichte) akku)))))

(define Teilgewichte-a '(1 1 40 2 3 5 15 15 20 40))
(Rucksack-packen 101 Teilgewichte-a)
(Rucksack-packen 102 Teilgewichte-a)
(Rucksack-packen 103 Teilgewichte-a)
(Rucksack-packen 104 Teilgewichte-a)
(Rucksack-packen 105 Teilgewichte-a)

(define Teilgewichte-b '(1 2 5 9 20 50 90 181 400 900))
(Rucksack-packen 101 Teilgewichte-b)
(Rucksack-packen 102 Teilgewichte-b)
(Rucksack-packen 103 Teilgewichte-b)
(Rucksack-packen 104 Teilgewichte-b)
(Rucksack-packen 105 Teilgewichte-b)
