;;; zwei rucksaecke ts.scm
;;; Damit es Alternativen gibt.
;;; Die beiden Ruckscke werden in den Alternativen gehalten.
(define
  (Rucksaecke-packen Max-1 Max-2 Teilgewichte)
  (let t-s
    ((Teilgewichte (cdr Teilgewichte))
     (Alternativen
      (Nachfolger (car Teilgewichte) '(() ()) Max-1 Max-2)))
    (cond
      ; Alles versucht! backtracking!
      ((null? Alternativen) #f)
      
      ; Treffer ?
      ((Ziel? (car Alternativen) Max-1 Max-2)
       (car Alternativen))
      
      ; Wir sind im Blatt angekommen.
      ; Dann geht es in diesem Zweig nicht weiter. backtracking!
      ((null? Teilgewichte) #f)
      
      ; Erste Alternative versuchen!
      ((t-s 
        (cdr Teilgewichte)
        (Nachfolger (car Teilgewichte) (car Alternativen) Max-1 Max-2)))
      
      (else
       ; die anderen Alternativen bearbeiten!
       (t-s
        Teilgewichte
        (cdr Alternativen))))))

;;; ===== Nachfolger =====
; neues Teilgewicht x Liste der beiden Ruckscke x Max-1 x Max-2 --> Liste der Alternativen
(define
  (Nachfolger Teilgewicht liste Max-1 Max-2)
  (append
   (if 
    (> (apply + (cons Teilgewicht (car liste))) Max-1)
    '()
    (list (list (cons Teilgewicht (car liste)) (cadr liste))))
   (if 
    (> (apply + (cons Teilgewicht (cadr liste))) Max-2)
    '()
    (list (list (car liste) (cons Teilgewicht (cadr liste)))))
   (list liste)))

;;; ===== Ziel? =====
; Rucksackliste x Max-1 x Max-2 --> #f / #t
(define
  (Ziel? Rucksackliste  Max-1 Max-2)
  (and
   (= Max-1 (apply + (car Rucksackliste)))
   (= Max-2 (apply + (cadr Rucksackliste)))))


(define Teilgewichte-a '(1 1 40 2 3 5 15 15 20 40 1 1 40 2 3 5 15 15 20 40))
(Rucksaecke-packen 101 102 Teilgewichte-a)
(Rucksaecke-packen 102 101 Teilgewichte-a)
(Rucksaecke-packen 101 103 Teilgewichte-a)
(Rucksaecke-packen 101 104 Teilgewichte-a)
(Rucksaecke-packen 101 105 Teilgewichte-a)

;(define Teilgewichte-b '(1 2 5 9 20 50 90 9 20 50 90 181 400 900))
;(Rucksaecke-packen 101 103 Teilgewichte-b)
;(Rucksaecke-packen 102 Teilgewichte-b)
;(Rucksaecke-packen 103 Teilgewichte-b)
;(Rucksaecke-packen 104 Teilgewichte-b)
;(Rucksaecke-packen 105 Teilgewichte-b)
