Programm ist unvollständig bearbeitet !!!
;;;                                   "container-ts-entwicklung.scm"
;;; Demonstration der Entwicklung des Programmes zur Tiefensuche am CLP
;;; Es wird mit bewerteten Stuecken und mit mehreren Containern gearbeitet.
(require (lib "breakpoint.ss"))
; ----- Liste der vorhandenen Stuecke -----
; Die Stuecke sind zweielementige Listen aus Masse (Volumen, Länge, ...) und Ertrag
; Ziel ist, bei den gegebenen Containern einen maximalen Ertrag zu erhalten.
; ((masse-1 ertrag-1) (masse-2 ertrag-2) ...)
; Die Stueckeliste ist bewusst ungeordnet (gibt ueberhaupt es eine Wohlordnung?)
(define
  stuecke
  '((15 15) (10 5) (30 20) (20 30) (40 30) (40 40) (10 20) (20 15) (15 20) (25 25) (40 50))
  )

; ----- Container-Liste -----
; Da es nun nicht nur einen gibt, müssen sie als Liste angegeben werden.
; Die container-liste besteht aus Listen, die am Kopf die Kapazitaet haben
; und dahinter die eingefuellten Stuecke.
;((kapazitaet-1 stueck-a stueck-b ...) ... )
(define container-liste '((120) (120) (100)))

;;; ===== ANFANG HILFSFUNKTIONEN =====
; ----- Hilfsfunktionen -----
; Man fuellt ein Stueck ein mit (cons ... ...), hier aber hinter die Kapazitaet
(define (hinein stueck container) (cons (car container) (cons stueck (cdr container))))

; ----- Berechnung des gesamten Fuellung eines Containers -----
; Prinzip: Bilde eine Liste der Fuellungswerte und addiere diese.
(define (fuellung container) (apply + (map car (cdr container))))

; ----- Berechnung des gesamten Ertrages eines Containers -----
; Prinzip: Bilde eine Liste der Ertragswerte und addiere diese.
(define (ertrag container) (apply + (map cadr (cdr container))))

; ----- Praedikate -----
; Fuer das Verstaendnis ist vermutlich einfacher, diese Prädikate auszugliedern:
; voll? prueft, ob alle Werte zusammen das Fassungsvermoegen ergeben.
; Der Container enthaelt das Fassungsvermoegen am Kopf.
(define (voll? container)    (= (car container) (fuellung container)))
; zu-voll? prueft, ob alle Werte zusammen das Fassungsvermoegen ueberschreiten
(define (zu-voll? container) (< (car container) (fuellung container)))

;;; ===== ENDE HILFSFUNKTIONEN =====

;;; ----- Funktionskopf -----
; 1. Schritt: Bestimmung des Funktionskopfes
; Hier ist nun nicht ein einzelner Container zu betrachten, sondern eine Liste
; von Containern. Ein Zielwert taucht nicht auf: Optimierungsproblem!
(define
  (tiefensuche stuecke container-liste)
  'wert-undefiniert)
; Testaufrufe:
(writeln "Schritt 1: ")
(tiefensuche stuecke () 105)
(tiefensuche stuecke () 100)

;;; ----- am Ziel? -----
; 2. Schritt: ich bin am Ziel, wenn ???
; Hier ist nun erst einmal zu klaeren, was denn ueberhaupt das Ziel ist
; und wie es ueberprueft werden kann. 
; DEFINITION DES ZIELS: Es soll eine Belegung mit maximalem Ertrag gefunden werden.
; Es zeigt sich, dass es notwendig ist, bei der Bearbeitung die bis dahin
; optimale Belegung der Container zu kennen.
; Das ist beim Aufruf in die Tiefe nicht das Problem, da sie uebergeben werden kann.
; Beim Ruecksprung allerdings muss sie als Wert zurueckgegeben werden damit sie
; auf der Stufe davor zur Verfuegung steht und zwar bis zum Ende. Hier ist also eine
; vollstaendige Suche notwendig! ===>>> REDESIGN BEIM KOPF
; Die Bedingung wird neu: Ob man am Ziel ist, laesst sich erst am Ende pruefen!
(define
  (tiefensuche stuecke container-liste bisher-bestes)
  (cond
    [(null? stuecke)                           ; 1.Bedingung
     bisher-bestes]                            ; ja-Fall. s.o.
    [else                                      ; und sonst?
     'wert-undefiniert]                        ; der "sonst"-Fall
    )
  )
; Testaufrufe:
(writeln "Schritt 3: ")
(tiefensuche '(5 2 1) '(30 30 30 15) 105)
(tiefensuche '(5 2 1) '(30 30 30 15) 100)
(tiefensuche '() '(30 30 30 15) 100)

;;; ----- zu voll -----
; 3. Schritt: das aktuelle Stueck passt nicht hinein.
; es wird weitergesucht ohne dieses Stueck.
(define
  (tiefensuche stuecke container-liste bisher-bestes)
  (cond
    [(null? stuecke)                           ; 1.Bedingung
     bisher-bestes]                            ; ja-Fall. s.o.
    [(zu-voll?                                 ; 2.Bedingung
      (hinein
       (erstes stuecke)
       (car container))
     (tiefensuche                              ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    [else                                             ; und sonst?
     'wert-undefiniert]                        ; der "sonst"-Fall
    )
  )

; Testaufrufe:
(writeln "Schritt 4: ")
(tiefensuche stuecke '() 105)
(tiefensuche stuecke '() 100)
(tiefensuche stuecke '() 103)
(tiefensuche stuecke '() 500)


;;; ----- der "sonst"-Fall ??? -----
; 5. Schritt: das aktuelle Stueck passt hinein.
; es gibt nur noch diese Möglichkeit. Es wird weitergesucht mit diesem Stueck
; im Container.
(define
  (tiefensuche stuecke container zielwert)
  (cond
    [(ziel? container zielwert)                ; 1.Bedingung
     container]                                ; ja-Fall
    [(null? stuecke)                           ; 2.Bedingung
     #f]                                       ; ja-Fall. #f kennzeichnet Misserfolg.
    [(zu-voll?                                 ; 3.Bedingung
      (hinein (erstes stuecke) container)      ; "probieren"
      zielwert)
     (tiefensuche                              ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    [else                                      ; und sonst?
     (tiefensuche                              ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      (hinein (erstes stuecke) container)      ; ... mit der neuen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    )
  )

; Testaufrufe:
(writeln "Schritt 5: ")
(tiefensuche stuecke '() 105)
(tiefensuche stuecke '() 100)
(tiefensuche stuecke '() 103)
(tiefensuche stuecke '() 500)

;;; ----- das war es noch nicht ! -----
; 6. Schritt: das Stueck einzupacken fuehrte ggf. in eine Sackgasse.
; wir muessen es auch ohne dies Stueck versuchen.
; Dazu muss der Aufruf mit dem Stueck (in die Tiefe) wie eine Bedingung behandelt
; werden. Wie das z.B. geht, s.u.
(define
  (tiefensuche stuecke container zielwert)
  (cond
    [(ziel? container zielwert)                ; 1.Bedingung
     container]                                ; ja-Fall
    [(null? stuecke)                           ; 2.Bedingung
     #f]                                       ; ja-Fall. #f kennzeichnet Misserfolg.
    [(zu-voll?                                 ; 3.Bedingung
      (hinein (erstes stuecke) container)      ; "probieren"
      zielwert)
     (tiefensuche                              ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
     [(tiefensuche                             ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      (hinein (erstes stuecke) container)      ; ... mit der neuen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    ;;; Eine der besonderen Moeglichkeiten von cond: Bedingung=Wert
    ;;; Die Bedingung hat einen Wert, der zurückgegeben werden kann.
    ;;; Bei erfolglosem Versuch brauchen wir dann hier den Wert #f,
    ;;; damit zum else gegangen wird.
    [else                                      ; und sonst?
     (tiefensuche                              ; kennen wir schon:  weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    )
  )

; Testaufrufe:
(writeln "Schritt 6: ")
(tiefensuche stuecke '() 105)
(tiefensuche stuecke '() 100)
(tiefensuche stuecke '() 103)
(tiefensuche stuecke '() 500)


;;; ----- Vervollständigung der Ausgabe -----
; 7. Schritt: kommentierte Ausgabe!
(define
  (tiefensuche stuecke container zielwert)
  (cond
    [(ziel? container zielwert)                ; 1.Bedingung
     (writeln "Fuellung " zielwert " erreicht mit Container " container)
     container]                                ; ja-Fall
    [(null? stuecke)                           ; 2.Bedingung
     #f]                                       ; ja-Fall. #f kennzeichnet Misserfolg.
    [(zu-voll?                                 ; 3.Bedingung
      (hinein (erstes stuecke) container)      ; "probieren"
      zielwert)
     (tiefensuche                              ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
     [(tiefensuche                             ; weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      (hinein (erstes stuecke) container)      ; ... mit der neuen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    ;;; Eine der besonderen Moeglichkeiten von cond: Bedingung=Wert
    ;;; Die Bedingung hat einen Wert, der zurückgegeben werden kann.
    ;;; Bei erfolglosem Versuch brauchen wir dann hier den Wert #f,
    ;;; damit zum else gegangen wird.
    [else                                      ; und sonst?
     (tiefensuche                              ; kennen wir schon:  weiter suchen ...
      (restliste stuecke)                      ; ... ohne das erste Element ...
      container                                ; ... mit der bisherigen Fuellung
      zielwert)]                               ; ... und dem selben Zielwert.
    )
  )

; Testaufrufe:
(writeln "Schritt 7: ")
(tiefensuche stuecke '() 105)
(tiefensuche stuecke '() 100)
(tiefensuche stuecke '() 103)
(tiefensuche stuecke '() 500)
