;;;                                            (magische Quadrate.scm)
(require (lib "breakpoint.ss"))
;;;                                          Albowski , 3'2001
;;; Auf der Grundlage von 8 Damen
;;; -----------------------------------------------------------------
; Es wird zwar prinzipiell mit dem Programm zur Tiefensuche
; gearbeitet, bei jeder neuen Besetzung n/2n/usw. wird aber geprft,
; ob die Bedingungen (constraints) verletzt werden. Ist das der
; Fall, wird der Ast nicht weiter verfolgt.

;;; ----- maxZahl ---------------------------------------------------
; Die Angabe der Zeilen und Spalten des Quadrates regelt maxZahl.
(define maxZahl 3)
;;; ----- Tiefensuche -----------------------------------------------

(define
  (Tiefensuche maxZahl)
  (letrec
      ((Gesamtzahl (* maxZahl maxZahl))
       (Summe (/ (* maxZahl (add1 Gesamtzahl)) 2)))
    (let
        t-s
      ((Anzahl 0)
       (Quadrat ())
       (Versuch Gesamtzahl))
      (cond
        ((zero? Versuch) #f)              ; erfolglos
        
        ((and
          (not (zero? Anzahl))
          (member (car Quadrat) (cdr Quadrat))) ; war schon
         #f)
        
        ((and
          (not (zero? Anzahl))
          (zero? (modulo Anzahl maxZahl))  ; Zeile voll
          (Zeilenfehler Summe maxZahl Quadrat))
         #f)
        
        ((and                     ; in der letzten Zeile
          (>= (quotient (sub1 Anzahl) maxZahl) (sub1 maxZahl))
          (Spaltenfehler Summe maxZahl Quadrat))
         #f)
        
        ((= Anzahl Gesamtzahl)            ; Quadrat voll
         (if
          (Diagonalenfehler Summe maxZahl Quadrat)
          #f
          (Darstellung Quadrat maxZahl)))
        
        ;;; Versuch in die Tiefe :
        ((t-s (add1 Anzahl) (cons Versuch Quadrat) Gesamtzahl))
        
        (else
         ;;; Abbau der Alternativen :
         (t-s Anzahl Quadrat (sub1 Versuch)))))))

;;; ===== Zeilenfehler ==============================================
; Prft die maxZahl ersten Elemente der Liste Quadrat.
(define
  (Zeilenfehler Summe maxZahl Quadrat)
  (not
   (= Summe 
      (apply 
       +
       (list-tail
        (reverse Quadrat)
        (- (length Quadrat) maxZahl))))))

;;; ===== Spaltenfehler =============================================
; Prft die Elemente der Liste Quadrat an den Positionen 1, 1+maxZahl
; usw. 
; Dazu wird jeweils die maxZahl-te Restliste gebildet.
(define
  (Spaltenfehler Summe maxZahl Quadrat)
  (not
   (= Summe 
      (let loop
        ((Summe-ist 0)
         (Quadrat Quadrat))
        (cond
          ((< (length Quadrat) (add1 maxZahl))
           (+ Summe-ist (car Quadrat)))
          (else
           (loop 
            (+ Summe-ist (car Quadrat))
            (list-tail Quadrat maxZahl))))))))

;;; ===== Diagonalenfehler =============================================
; Prft die Elemente der beiden Diagonalen.
; usw. 
;;; Dazu wird einmal jeweils die maxZahl+1-te Restliste gebildet:
(define
  (Hauptdiagonalenfehler Summe maxZahl Quadrat)
  (not
   (= Summe 
      (let loop
        ((Summe-ist 0)
         (Quadrat Quadrat))
        (cond
          ((< (length Quadrat) (add1 maxZahl))
           (+ Summe-ist (car Quadrat)))
          (else
           (loop 
            (+ Summe-ist (car Quadrat))
            (list-tail Quadrat (add1 maxZahl)))))))))
;;; Andererseits wird beginnend beim maxZahl-ten Element jeweils die
;;; maxZahl-1-te Restliste gebildet:
(define
  (Nebendiagonalenfehler Summe maxZahl Quadrat)
  (not
   (= Summe 
      (let loop
        ((Summe-ist 0)
         (Quadrat (list-tail Quadrat (sub1 maxZahl))))
        (cond
          ((< (length Quadrat) (add1 maxZahl))
           (+ Summe-ist (car Quadrat)))
          (else
           (loop 
            (+ Summe-ist (car Quadrat))
            (list-tail Quadrat (sub1 maxZahl)))))))))
;;; Und die Zusammenfassung:
(define
  (Diagonalenfehler Summe maxZahl Quadrat)
  (or
   (Hauptdiagonalenfehler Summe maxZahl Quadrat)
   (Nebendiagonalenfehler Summe maxZahl Quadrat)))

;;; ===== Darstellung ===============================================
(define
  (Darstellung Quadrat maxZahl)
  (let loop
    ((Quadrat Quadrat))
    (cond
      ((null? Quadrat) (newline))
      ((zero? (modulo (sub1 (length Quadrat)) maxZahl))
       (fuenf-Zeichen (car Quadrat))
       (newline)
       (loop (cdr Quadrat)))
      (else
       (fuenf-Zeichen (car Quadrat))
       (loop (cdr Quadrat))))))

;;; ===== fuenf-Zeichen ==========================================
(define
  (fuenf-Zeichen Zahl)
  (display
   (string-append 
    (substring 
     "     " 
     0 
     (- 5 
        (string-length (number->string Zahl))))
    (number->string Zahl))))
;;;==================================================================
; maxZahl = 3:
;    2    7    6
;    9    5    1
;    4    3    8

; maxZahl = 4: (nach deprimierend langer Zeit!)
;    8   11    6    9
;   13    7   10    4
;   12   14    3    5
;    1    2   15   16

(Tiefensuche maxZahl)
