;;; breakpoint.scm
;;; vvvvv bkpt vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; bkpt - ben?tigt writeln und warte-taste
; kann auch ohne Parameter aufgerufen werden und bietet die M?glichkeit,
; eine Funktion zu unterbrechen und ggf. Ausdr?cke
; auszuwerten und anzuzeigen.
(define
  (bkpt . Parameter)
  (apply writeln Parameter)
  (warte-taste))

;;; vvvvv break-value vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; break-value  - ben?tigt writeln und warte-taste
; muss als ersten Parameter den zu ?bergebenen Wert bekommen und
; gibt diesen Wert zur?ck.
; kann auch au?erdem noch Parameter Ausdr?cke auswerten und anzeigen.
(define
  (break-value value . Parameter)
  (if
   (not (null? Parameter))
   (apply writeln (cons "Parameter: " Parameter)))
  (writeln "Wert: " value)
  (warte-taste)
  value)


;;; vvvvv warte-taste vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; warte-taste - keine Parameter m?glich
; wartet auf einen Tastendruck mit anschlie?endem ENTER
(define
  (warte-taste)
  (writeln "weiter mit          <Leertaste>   und   <ENTER>")
  (writeln "Abbruch mit F[e]hler   <e>        und   <ENTER>")
  (let
      ((ch (peek-char)))
    (read-line)
    (cond
      ((equal? ch #\newline)(warte-taste))
      ((char=? ch #\space)(void))
      ((or (char=? ch #\E) (char=? ch #\e))
       (error "Abbruch mit Fehlermeldung"))
      (else
       (warte-taste)))))

;;; vvvvv writeln vvv vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; writeln - beliebige Parameter m?glich
(define
  (writeln . daten)
  (cond
    ((null? daten) (newline))
    (else
     (display (car daten))
     (display #\space)
     (apply writeln (cdr daten)))))
;;; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
