;;;                                        <Missio Kani Original.scm>
(require (lib "breakpoint.ss"))
;;; >>>>> Vorbemerkungen <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;;; Bei der hier betrachteten Variante muss zu jeder Zeit auf jeder
;;; Seite die Zahl der Missionare mindestens so gross sein wie die
;;; der  Kannibalen, zustzlich tritt die Forderung auf, dass nur
;;; einer der Kannibalen Fhrmann sein kann.
;;; Die Gesamtzahl der Missionare und der Kannibalen muss vor und
;;; nach einem Transport jeweils konstant 3 sein, so dass nur eine
;;; Seite verwaltet werden muss.

;;; Es werden beim Generieren der Nachfolger zunchst alle Zustnde
;;; generiert und dann die unzulssigen aussortiert.
;;; ===== Start- und Zielzustand ====================================
;;;               Missionare Kannibalen Fhrmann Boot
(define Start-Zustand (list 3 2 1 'links))
(define Ziel-Zustand (list 0 0 0 'rechts))
;;; ===== Zugriffsfunktionen ========================================
; Zugriffsfunktionen fr die einzelnen Komponenten.
(define (Liegeplatz Zustand) (cadddr Zustand))
(define (M-links Zustand) (car Zustand))
(define (K-links Zustand) (cadr Zustand))
(define (F-links Zustand) (caddr Zustand))
(define (K+F-links Zustand) (+ (K-links Zustand) (F-links Zustand)))
(define (M-rechts Zustand) (- 3 (M-links Zustand)))
(define (K-rechts Zustand) (- 2 (K-links Zustand)))
(define (F-rechts Zustand) (- 1 (F-links Zustand)))
(define (K+F-rechts Zustand) (- 3 (K+F-links Zustand)))

;;; ===== Bedingungen ===============================================
; Es treten Bedingungen fr links und fr rechts auf.
;;; ----- OK --------------------------------------------------------
(define
  (OK Zustand)
  (cond
    ((negative? (M-links Zustand)) ())
    ((negative? (K-links Zustand)) ())
    ((negative? (F-links Zustand)) ())
    ((negative? (M-rechts Zustand)) ())
    ((negative? (K-rechts Zustand)) ())
    ((negative? (F-rechts Zustand)) ())
    ((zero? (M-links Zustand)) (list Zustand))
    ((zero? (M-rechts Zustand)) (list Zustand))
    ((> (K+F-links Zustand) (M-links Zustand)) ())
    ((> (K+F-rechts Zustand) (M-rechts Zustand)) ())
    (else (list Zustand))))

;;; ===== Boote =====================================================
; Es werden die mglichen Boote definiert. Sie bekommen den aktuellen
; Zustand bergeben und geben eine Liste mit dem Zielzustand zurck.
; Der Verschiebunsoperator ergibt sich aus der Richtung.
;;; ----- Boot-1 ----------------------------------------------------
; Zwei Missionare.
(define
  (Boot-1 Zustand)
  (list 
   (+ (M-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -2 2))
   (K-links Zustand)
   (F-links Zustand)
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ----- Boot-2 ----------------------------------------------------
; Kannibale mit Fhrmann.
(define
  (Boot-2 Zustand)
  (list 
   (M-links Zustand)
   (+ (K-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (+ (F-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ----- Boot-3 ----------------------------------------------------
; Missionar und Kannibale.
(define
  (Boot-3 Zustand)
  (list 
   (+ (M-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (+ (K-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (F-links Zustand)
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ----- Boot-4 ----------------------------------------------------
;  Missionar und Fhrmann.
(define
  (Boot-4 Zustand)
  (list 
   (+ (M-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (K-links Zustand)
   (+ (F-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ----- Boot-5 ----------------------------------------------------
; Ein Missionar.
(define
  (Boot-5 Zustand)
  (list 
   (+ (M-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (K-links Zustand)
   (F-links Zustand)
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ----- Boot-6 ----------------------------------------------------
; Der Fhrmann.
(define
  (Boot-6 Zustand)
  (list 
   (M-links Zustand)
   (K-links Zustand)
   (+ (F-links Zustand)
      (if (equal? (Liegeplatz Zustand) 'links) -1 1))
   (if (equal? (Liegeplatz Zustand) 'links) 'rechts 'links)))

;;; ===== Nachfolger ================================================
; Generiert alle zulssigen Nachfolger eines Zustandes.
(define
  (Nachfolger Zustand)
;  (bkpt (links-OK (Boot-1 Zustand)) Zustand)
   (append
    (OK (Boot-1 Zustand))
    (OK (Boot-2 Zustand))
    (OK (Boot-3 Zustand))
    (OK (Boot-4 Zustand))
    (OK (Boot-5 Zustand))
    (OK (Boot-6 Zustand))))

;;; ===== Tiefensuche ===============================================
; Der Suchraum entfllt.
(define
  (Tiefensuche Start Ziel)
  
  (let
      t-s
    ((Alternativen (Nachfolger Start))
     (besucht (list Start)))
    ;(bkpt besucht)
    
    (cond
      ((null? Alternativen) #f)
      
      ((equal? (car Alternativen) Ziel)
       (writeln (reverse (cons (car Alternativen) besucht)))
       (newline)
       #t)
      
      ((member (car Alternativen) besucht)
       (t-s
        (cdr Alternativen)
        besucht))
      
      (else
       (t-s
        (Nachfolger (car Alternativen) )
        (cons (car Alternativen) besucht))
      
       (t-s
        (cdr Alternativen)
        besucht)))))

    
;;; ----- Tests -----------------------------------------------------
(Tiefensuche Start-Zustand Ziel-Zustand)
