;;;                      <Tiefensuche stack selbstverwaltet.scm>
;;;                                     bearbeitet November 2000
;;; Der STACK wird selbst verwaltet.
;;; Der Sinn dieses Programmes ist die Vorbereitung der Breiten-
;;; suche.
;;;
(require (lib "breakpoint.ss"))
;(load "Grosser Graph.scm")
;;; Muster der Datenstruktur:
;;; ( (1.Knoten (1.Nachfolger 2.Nachfolger ...))
;;;   (2.Knoten (1.Nachfolger 2.Nachfolger ...))
;;;    ... )
;;;==============================================================
; Vorbemerkung :
; Die Alternativen liessen sich als Teil des stacks mit verwalten.

; [Anm.1] : Wenn auf einer Ebene alle Alternativen untersucht
; wurden, muss untersucht werden, ob auf der vorigen Ebene noch
; Wege unversucht geblieben sind. Die verbliebenen Alternativen
; dieser Ebene finden wir im stack an der ersten Position.

; [Anm.2] : Da waren wir schon! s.o.

; [Anm.3] : Wenn das Ziel erreicht wurde, wird die Liste der be-
; suchten Knoten in der richigen Reihenfolge ausgegeben und es
; wird mit dem Wert "#t" zur aufrufenden Ebene zurueckgesprungen.

; [Anm.4] : Hier erfolgt sonst der eigentliche Abstieg in der
; Rekursion. Das Programm darf hier bei einem selbst verwalteten 
; stack keine neuen Ebenen schaffen. Die Aufrufe koennen und
; mssen echt endrekursiv sein.

(define
  (Tiefensuche Start Ziel Graph)
  (let
      t-s
    ((Alternativen (Nachfolger Start Graph))
     (stack '())
     (besucht (list Start)))

      (writeln Alternativen stack besucht)
    (cond
      
      ((and
        (null? Alternativen)
        (null? stack))
       #f)                    ; Problem ist nicht lsbar
      
      ((null? Alternativen)
       (t-s                                        ; [Anm.1]
        (car stack)       ; Alternativen der vorigen Ebene
        (cdr stack)       ; Reststack
        (cdr besucht)))   ; Knoten von Besuchtliste entfernen
      
      ((member (car Alternativen) besucht)         ; [Anm.2]
       (t-s
        (cdr Alternativen)
        stack
        besucht))
      
      ((eq? (car Alternativen) Ziel)                 ; [Anm.3]
       (display (reverse (cons (car Alternativen) besucht)))
       #t)
      
      (else                                          ; [Anm.4]
       (t-s
        (Nachfolger (car Alternativen) Graph)
        (cons (cdr Alternativen) stack)
        (cons (car Alternativen) besucht))))))

(define
   (Nachfolger Element Graph)
   (cadr (assoc Element Graph)))

;;;==============================================================
(define
   Graph
   '( (1 (2 4))
      (2 (1 3))
      (3 (2 6))
      (4 (1 5 7))
      (5 (4 6 8))
      (6 (3 5))
      (7 (4))
      (8 (5 9))
      (9 (8))))

;;;==============================================================
;;; Labyrinth dazu :
;;;                
;;;                1 - 2 - 3
;;;                I  I
;;;                4 - 5 - 6
;;;                I  I I
;;;                7  8 - 9
;;;                
;;;==============================================================
(Tiefensuche 1 3 Graph)
(Tiefensuche 1 7 Graph)
(Tiefensuche 1 9 Graph)
(Tiefensuche 1 11 Graph)
