;;;                    <einfache-tiefensuche-mit-unterbrechungen.scm>
; Unterbrechungen ermöglichen:
(require (lib "breakpoint.ss"))
; Unterbrechnungsfunktionen sind: (bkpt . Parameter) (break-value value . Parameter) (warte-taste) (writeln . daten)
; warte
;;; ----- die Kantenliste -----
(define
  Kantenliste
  '((0 (3))
    (1 (2 4))
    (2 (1))
    (3 (0 4))
    (4 (1 3 5 7))
    (5 (4 8))
    (6 (9))
    (7 (4 8 10))
    (8 (5 7))
    (9 (6 10 12))
    (10 (7 9 11 13))
    (11 (10))
    (12 (9))
    (13 (10 14))
    (14 (13)))
  )
;;; ----- Nachfolger -----
; Sie greift auf die Kantenliste zu, welche die Form einer Assoziationsliste hat.
; Dafür gibt es eine Standardfunktion von Scheme: assoc.
(define
  (Nachfolger Element Liste)
  (car (cdr (assoc Element Liste))))

;;; ----- Tiefensuche -----
; 4. Schritt: besucht-Liste
; In einer besucht-Liste werden die schon besuchten Knoten geführt.
; Als weitere Verbesserung wird zunächst getestet, ob der Zielknoten unter den
; Alternativen zu finden ist.
(define
  (Tiefensuche Kantenliste Zielknoten Alternativen besucht-Liste)
  ;(bkpt Alternativen besucht-Liste)
  (cond
    [(null? Alternativen)                             ; Misserfolg hier
     #f]
    [(member Zielknoten Alternativen)                 ; 2.Bedingung verbessert
     (cons Zielknoten besucht-Liste)]                 ; Weg ausgeben
    [(member (car Alternativen) besucht-Liste)        ; 3.Bedingung prueft die besucht-Liste
     (Tiefensuche                                     ; dann zum naechsten Nachfolger gehen  
      Kantenliste
      Zielknoten
      (cdr Alternativen)
      besucht-Liste)]
    [(Tiefensuche                                     ; Schritt in die Tiefe ...
      Kantenliste
      Zielknoten
      (Nachfolger (car Alternativen) Kantenliste)     ; ... mit den Nachfolgern
      (cons (car Alternativen) besucht-Liste))]       ; und der verlängerten besucht-Liste
    [else                                             ; und sonst ...
     (Tiefensuche                                     ; ... zum naechsten Nachfolger gehen 
      Kantenliste
      Zielknoten
      (cdr Alternativen)
      besucht-Liste)]
    )
  )


(Tiefensuche Kantenliste 9 (Nachfolger 0 Kantenliste) '(0))

