;;;                           <grosser-graph.scm>
(require (lib "breakpoint.ss"))
;;;==================================================================
; erzeugt zunaechst ein rechteckiges Grundmuster, noch ohne
; Verbindungen, in die dann alle zulaessigen Verbindungen eingebaut
; werden.
(define
  (erzeuge-Grundmuster breite hoehe)
  (let
      loop-1
    ((akku ())
     (zeile 0))
    (let
        loop-2
      ((zeilen-akku ())
       (spalte 0))
      (cond
        ((>= zeile hoehe)
         (reverse akku))
        ((>= spalte breite)
         (loop-1 (append zeilen-akku akku) (add1 zeile)))
        (else
         (loop-2 
          (cons (alle-nachbarn zeile spalte breite hoehe) zeilen-akku) 
          (add1 spalte)))))))

;;; ===== alle-nachbarn =============================================
; baut in den Graph ohne Verbindungen alle Verbindungen ein, die
; f?r ein rechteckigen [breite x hoehe] Graph zul?ssig sind.
(define
  (alle-nachbarn zeile spalte breite hoehe)
  (list
   (+ (* zeile breite) spalte)
   (append
    (if (> zeile 0) (list (+ (* (sub1 zeile) breite) spalte)) ())
    (if (> spalte 0) (list (+ (* zeile breite) (sub1 spalte))) ())
    (if (< spalte (sub1 breite)) (list (+ (* zeile breite) (add1 spalte))) ())
    (if (< zeile (sub1 hoehe)) (list (+ (* (add1 zeile) breite) spalte)) ())
    )))

;;; ===== entferne-Wege =============================================
; erm?glicht in einer Schleife mehrere Verbindungen zu l?schen.
(define
  (entferne-Wege breite hoehe Graph gerichtet?)
  (let
      loop
    ((Graph Graph))
    (zeige-Graph breite hoehe Graph)
    (display "Gib den Knoten an ! <Abbruch: #f>")(newline)
    (let
        ((knoten (read)))
      (cond
        (knoten
         (display (nachbarn knoten Graph))
         (display " welcher Weg soll entfernt werden ?")
         (let
             ((ziel (read)))
           (loop
            (entferne-den-weg knoten ziel Graph gerichtet?))))
        (else
         Graph)))))
;;; ===== nachbarn ==================================================
; bestimmt zu einem Knoten die Liste seiner Nachbarn im Graph.
(define
  (nachbarn knoten graph)
  (cadr (assoc knoten graph)))

;;; ===== entferne-den-weg ==========================================
; entfernt einen Weg aus einem Graph. 
; Dabei wird ber?cksichtigt, dass bei ungerichteten Graphen 
; [Parameter ist dann #f] beide Richtungen zu entfernen sind.
; Daher ruft die Funktion sich in diesem Fall mit ausgetauschten
; Knoten selbst aus.
(define
  (entferne-den-weg knoten ziel Graph gerichtet?)
  (writeln knoten ziel)
  (let
      ((Graph
        (if
         (not gerichtet?)
         (entferne-den-weg ziel knoten Graph #t)
         Graph)))
    (let
        ((zu-bearbeiten (assoc knoten Graph)))
      (append
       (reverse (cdr (member zu-bearbeiten (reverse Graph))))
       (list
        (list
         (car zu-bearbeiten)
         (append
          (reverse (cdr (member ziel (reverse (cadr zu-bearbeiten)))))
          (cdr (member ziel (cadr zu-bearbeiten))))))
       (cdr (member zu-bearbeiten Graph))))))

;;; ===== zeige-Graph ============================================
(define
  (zeige-Graph breite hoehe Graph)
  (let
      loop-1
    ((zeile 0))
    (let
        loop-2
      ((spalte 0)
       (zwischen-zeile ""))
      (cond
        ((>= zeile hoehe)
         (void))
        ((>= spalte breite)
         (newline)(newline)(display zwischen-zeile)(newline)(newline)
         (loop-1 (add1 zeile)))
        (else
         (let
             ((zahl (+ (* zeile breite) spalte)))
           (display 
            (string-append
             (substring 
              (string-append 
               (number->string zahl)
               "     ")
              0 5)
             (if 
              (member (add1 zahl) (nachbarn zahl Graph))
              "---   "
              "      ")))
           (loop-2 
            (add1 spalte)
            (string-append
             zwischen-zeile
             (if 
              (member (+ zahl breite) (nachbarn zahl Graph))
              "|          "
              "           ")))))))))

;;; ----- Tests -----
;(erzeuge-Grundmuster 3 5)
;(zeige-Graph 3 5 (erzeuge-Grundmuster 3 5))
(define Graph (entferne-Wege 3 5 (erzeuge-Grundmuster 3 5) #f))

