;;; OO-Grafik
;; Verwendet die PLT MrEd: Graphical Toolbox

;; Modell:
(define
  kanten-liste
  '((0 (3))
    (1 (2 4))
    (2 (1))
    (3 (0 4))
    (4 (1 3 5 7))
    (5 (4 8))
    (6 (9))
    (7 (4 8 10))
    (8 (5 7))
    (9 (6 10 12))
    (10 (7 9 11 13))
    (11 (10))
    (12 (9))
    (13 (10 14))
    (14 (13))))
; oder:
(load "grosser-graph.scm")(define kanten-liste Graph)

; start-knoten muss definiert sein, ziel-knoten kann definiert sein.
(define start-knoten 0)
(define (nachfolger knoten) (cadr (assoc knoten kanten-liste)))
(define ziel-knoten 9)        ; '())


;;;; ====== Grafik =====
;; erzeuge ein dialog - Objekt
(define dialog (instantiate dialog% ("Suche im Graphen")))
;; text-field zur Anzeige des aktuellen Knoten
(define
  aktueller-knoten-anzeige
  (new
   text-field%
   (label "aktueller Knoten")
   (parent dialog)
   (callback void)
   (init-value (number->string start-knoten))
   (enabled #f)
   (vert-margin 20)
   (horiz-margin 20)))

;; list-box zur Anzeige und Auswahl der Nachfolgeknoten
(define
  nachfolge-knoten-liste
  (instantiate
      list-box%
    ("Nachfolge-Knoten" (map number->string (nachfolger start-knoten)) dialog void '(single) )))

;; Add a horizontal panel to the dialog, with centering for buttons
(define panel (instantiate horizontal-panel% (dialog) (alignment '(center center))))

;; Hilfsfunktionen für die list-box
; löscht alle Elemente in der list-box
; [wird hier nicht benötigt]
(define
  (loesche-alle list-box)
  (let loop
    ((n (send list-box get-number)))
    (cond
      ((zero? n) (void))
      (else
       (send list-box delete (sub1 n))
       (loop (sub1 n))))))

;; gibt den ausgewählten Knoten zurück
; die innerere Funktion holt den ausgewählten Index,
; die äußere holt dessen Inhalt.
(define
  (ausgewaehlter-knoten)
  (string->number
   (send nachfolge-knoten-liste get-string
         (send nachfolge-knoten-liste get-selection))))

;; für den weiter-Button die aktion und das Objekt
; der weiter-Button wird dem horizontal panel hinzugefügt
(define 
  (weiter-aktion)
  (lambda (b e)
    (let
        ((knoten  (ausgewaehlter-knoten)))
      (display knoten)(newline) ; für eine Ausgabe des Weges in der Konsole
      (cond
        ((equal? knoten ziel-knoten)
         (display (string-append "Am Ziel: " (number->string knoten)))(newline)(send dialog show #f))
        (else
         (send
          aktueller-knoten-anzeige
          set-value 
          (number->string knoten))
         (send
          nachfolge-knoten-liste
          set
          (map number->string (nachfolger knoten)))
         (send nachfolge-knoten-liste set-selection 0))))))

(define weiter-button (instantiate button% ("weiter" panel (weiter-aktion))))

;; für den beenden-Button die aktion und das Objekt
; der beenden-Button wird dem horizontal panel hinzugefügt
(define beenden-aktion (lambda (b e) (display 'beendet)(newline)(send dialog show #f)))
(define beenden-button (instantiate button% ("Beenden" panel beenden-aktion)))

;; Formatierungen
(send weiter-button min-width 100)
(send beenden-button min-width 100)
(send panel vert-margin 10)

;; Show the dialog
(send dialog show #t)
